<?php
/* !! Pré-Requis : Le fichier config.php doit être correctement renseigné !!
 *
 * > Test si la connexion MySQL se fait bien.
 * > Demander un mot de passe pour le compte admin
 * > Création des tables MySQL
 * > Générer un grain de sel
 * > Enregistrer le tout
 */

define('INWWW', 1);

include('./includes/config.php');
include('./includes/functions.php');

include('./includes/classes/Secure.class.php');


// Connexion MySQL
if(!mysql_connect($CFG['bdd']['host'],$CFG['bdd']['username'],$CFG['bdd']['password']))
    $System->stopSystem('Erreur de connexion à la base de donnée.');

if(!mysql_select_db($CFG['bdd']['schema']))
    $System->stopSystem('Erreur sur la base de donnée [No Selection].');

mysql_query("SET NAMES ".$CFG['encoding']);
mysql_set_charset($CFG['encoding']);
// --


// déjà installé ?
if(mysql_table_exists(DB_FILE_TABLE, $CFG['bdd']['schema']) || mysql_table_exists(DB_CFG_TABLE, $CFG['bdd']['schema']))
    exit('INSTALLATION IMPOSSIBLE :: Vous avez déjà installé MyPHPUpload.');




// Test de CHMOD sur le répertoire d'upload et le répertoire de cache
$liste_a_tester = array(
                        $CFG['upload_dir'],
                        $CFG['upload_cache_dir']
                      );
clearstatcache();

$perms_Errors = '';
foreach($liste_a_tester as $key=>$valeur)
{
    $lemod = @chmodnum(getperms($valeur));

    if(!is_writable($valeur))
        $perms_Errors .= '<p>'.$valeur.' <span style="color:red"><u>n\'est PAS</u> accessible en &eacute;criture.</span> Valeur CHMOD actuel : <span style="color:red">'.$lemod.'</span></p>';
}

if(!empty($perms_Errors))
{
    echo '
    <h1>Installation</h1>
    <h2>Infos de connexion administrateur</h2>'.$perms_Errors;

    echo '<p><b>Pour continuer, vous devez absolument rendre les deux répertoires accessibles en lecture et en écriture (CHMOD 0777).</b></p>';

    exit();
}


// On demande le mot de passe
if(!$_POST)
{
    echo '
    <h1>Installation</h1>
    <h2>Infos de connexion administrateur</h2>
    <p>Renseignez ici les informations que vous allez utiliser pour la connexion sécurisé à l\'administration.</p>
    <form name="form" method="post" action="">
        <table width="100%">
            <tr>
                <td width="130">Login</td>
                <td><input name="login" type="text" id="login" /></td>
            </tr>
            <tr>
                <td>Mot de passe</td>
                <td><input name="password" type="text" id="password" /></td>
            </tr>
            <tr>
                <td colspan="2"><input type="submit" name="Submit" value="Valider et terminer l\'installation >" /></td>
            </tr>
        </table>
    </form>';
}
else
{

    if(empty($_POST['password']) || strlen($_POST['password']) < 4)
    {
        exit('Le mot de passe est vide OU fais moins de 4 caractères. Merci de cliquer sur Retour.');
    }

    if(empty($_POST['login']))
    {
        exit('Le login est vide. Merci de cliquer sur Retour.');
    }
    
    // le grain de sel pour sécurisé les mots de passe
    $salt = uniqid('H', 3);

    // encodage du mot de passe
    $password = md5($_POST['password'] . $salt);
    $login = Secure::smartQuote($_POST['login']);


    // Création des tables MySQL
    $data_Sql = array();

    $data_Sql[] = '
    CREATE TABLE IF NOT EXISTS `'.DB_FILE_TABLE.'` (
      `id` int(8) NOT NULL auto_increment,
      `date` int(10) NOT NULL,
      `reference` varchar(38) NOT NULL default \'\',
      `file_name` varchar(38) NOT NULL default \'\',
      `file_real_name` varchar(200) NOT NULL,
      `ip` varchar(15) NOT NULL default \'\',
      `nbr_view` mediumint(7) NOT NULL default \'0\',
      `nbr_dl` mediumint(7) NOT NULL default \'0\',
      PRIMARY KEY  (`id`),
      KEY `reference` (`reference`)
    ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;';

    $data_Sql[] = '
    CREATE TABLE IF NOT EXISTS `'.DB_CFG_TABLE.'` (
      `clef` varchar(30) character set utf8 NOT NULL,
      `valeur` varchar(50) character set utf8 NOT NULL,
      KEY `key` (`clef`)
    ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;';

    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='admin_login', valeur='$login'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='admin_password', valeur='$password'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='salt', valeur='$salt'";


    foreach($data_Sql as $n => $requete)
    {
        if(!mysql_query($requete))
            exit('Erreur lors de la création des tables MySQL : '.mysql_error());
    }


    // Les tables sont ajouté à la BDD :: Cool !


    // On affiche le message comme quoi tout va bien
    echo '
    <h1>Installation</h1>
    <h2>SUCCES</h2>
    <p>L\'installation est terminée.</p>
    <p>
        Login : admin<br />
        Mot de passe : '.Secure::safest($_POST['password']).'
    </p>
    <p><a href="./?m=admin">Accès à l\'administration</a></p>
    <p><a href="./?m=files">Accès à MyPHPUpload</a></p>
    ';
}











function chmodnum($mode)
{
    $mode=substr($mode,-9);// on prend les 9 derniers, marche avec fichiers ou dossiers
    $mode = str_pad($mode,9,'-');
    $trans = array('-'=>'0','r'=>'4','w'=>'2','x'=>'1');
    $mode = strtr($mode,$trans);

    $newmode = '';
    $newmode .= $mode[0]+$mode[1]+$mode[2];
    $newmode .= $mode[3]+$mode[4]+$mode[5];
    $newmode .= $mode[6]+$mode[7]+$mode[8];
    return $newmode;
}

function getperms($file)
{
    if(@function_exists(fileperms))
    {

        $perms = fileperms($file);
        if (($perms & 0xC000) == 0xC000) {
            // Socket
            $info = 's';
        } elseif (($perms & 0xA000) == 0xA000) {
            // Lien symbolique
            $info = 'l';
        } elseif (($perms & 0x8000) == 0x8000) {
            // Régulier
            $info = '';
        } elseif (($perms & 0x6000) == 0x6000) {
            // Block spécial
            $info = 'b';
        } elseif (($perms & 0x4000) == 0x4000) {
            // Dossier
            $info = 'd';
        } elseif (($perms & 0x2000) == 0x2000) {
            // Caract�re sp�cial
            $info = 'c';
        } elseif (($perms & 0x1000) == 0x1000) {
            // FIFO pipe
            $info = 'p';
        } else {
            // Inconnu
            $info = 'u';
        }

        // Propriétaire
        $info .= (($perms & 0x0100) ? 'r' : '-');
        $info .= (($perms & 0x0080) ? 'w' : '-');
        $info .= (($perms & 0x0040) ?
        (($perms & 0x0800) ? 's' : 'x' ) :
        (($perms & 0x0800) ? 'S' : '-'));

        // Groupe
        $info .= (($perms & 0x0020) ? 'r' : '-');
        $info .= (($perms & 0x0010) ? 'w' : '-');
        $info .= (($perms & 0x0008) ?
        (($perms & 0x0400) ? 's' : 'x' ) :
        (($perms & 0x0400) ? 'S' : '-'));

        // Tous
        $info .= (($perms & 0x0004) ? 'r' : '-');
        $info .= (($perms & 0x0002) ? 'w' : '-');
        $info .= (($perms & 0x0001) ?
        (($perms & 0x0200) ? 't' : 'x' ) :
        (($perms & 0x0200) ? 'T' : '-'));

        return $info;

    }

    $errorfunction = '<b>Indeterminé</b>, fonction php fileperms() absent';

    return $errorfunction;
}